#pragma once
#include "libexif/exif-utils.h"
#include "libexif/exif-data.h"
#include "libexif/exif-content.h"
#define OExifOrientation_NULL 0
#define OExifOrientation_TOP 1//
#define OExifOrientation_LEFT 2//ʾƬ߳ˡҪʱת90
#define OExifOrientation_BOTTOM 3//180
#define OExifOrientation_RIGHT 4//270

#define OEXIF_RET_ERR -1
#define OEXIF_RET_LNG 0x1
#define OEXIF_RET_LAT 0x2
#define OEXIF_RET_ALT 0x4
#define OEXIF_RET_OTHER 0x1000

#define OEXIF_RET_LL (OEXIF_RET_LAT|OEXIF_RET_LNG)
#define OEXIF_RET_LL_EXT (OEXIF_RET_LL|OEXIF_RET_ALT)

//
//#define LOADEXIF_ERR -1
//#define LOADEXIF_SUC 0
//#define LOADEXIF_LNG 1
//#define LOADEXIF_LAT 2
//#define LOADEXIF_ALT 4
//#define LOADEXIF_FULL_GPS 7
//
#define  SAVEEXIF_FILE_ERR -1
#define  SAVEEXIF_HEADER_ERR -2
#define  SAVEEXIF_MALLOC_ERR -3
#define  SAVEEXIF_SAVE_ERR -4
//pStrComentҪڽṹͷ
struct tagOExifInfo
{
	
	char strXpTitle[100];//  //
	char* pStrComent; //ע
	int szOfComent;//cעС
	char strXpAuthor[100]; //
	char strXpKeyword[100];// ؼ  //
	char strXpSubject[100]; //
	char strName[100];//ļ
	char strPath[256];//ļ·
	char strFullPath[356];//ȫ·
	float fSize;//ļС
	unsigned int dwCTime;//ʱ
	unsigned int dwMTime;//޸ʱ
	//int nbKeyword;//ûйؼ

	unsigned int dwDateTime;//  //
	double dLat;//γ
	double dLng;//
	int iAlt;	//

	char strMake[32];//
	char strModel[40];//
	int nWidth;//Exifͼ
	int nHeight;//Exifͼ߶
	int nFocalLength;//
	float fExposureTime;//عʱ
	float fApertureFNumber;//Ȧ
	int nISOequivalent;//ISOй
	int nFocalplaneXRes;//ˮƽֱ
	int nFocalplaneYRes;//ֱֱ
	BYTE bOrientation;//
	int iLoadOK;

	int nbKeyword;
};

class OExif
{
protected:
	ExifData* m_pExif;
	char m_strFn[256];
	bool GetEntry(char *buf, int tag,int ibufLen = -1);
	bool GetEntryString(char *buf, int size, int tag);
	bool InitExifData();
	ExifEntry* create_tag(ExifIfd ifd, ExifTag tag, size_t len);
	void DecodePathAndName(const char *strFullPath);
	bool EditEntryString(char *strBuf, char *strOeiToSave, int iSize, ExifIfd iIFD, ExifTag iTag,bool bToBeUtf16 = false);
	int DecodeDateTime(const char *strTime);
	int DecodeExif();
	//void test(void *pBufSrc, int nBufSrc);
	int SaveExifToBuf(void *pBufSrc, int nBufSrc, char**pBufDst,bool bHasExif);
	bool EditEntryValue(long lValue, int tag,bool bCreate=true);
	bool EditEntryValue(int iValue, int tag, bool bCreate =true);
	bool EditEntryValue(short sValue, int tag, bool bCreate =true);
public:
	OExif();
	~OExif();
	tagOExifInfo m_oei;
	int LoadExif(const char* strPath);
	int LoadExif(void *pBuf, int nBuf);
	bool ClearOrientation();
	bool EditGps(double dLat, double dLng, double dAlt = 0, int iTol = 10e6);
	bool EditMake(char* strMake);
	bool EditModel(char* strModel);
	bool EditKeyword(char* strKeyword);
	bool EditSubject(char* strSubject);
	bool EditAuthor(char* strAuthor);
	bool EditCommnet(char* strComment);
	bool EditTitle(char* strTitle);
	bool EditPixel(int iWid, int iHei);
	//bool EditCreateTime(unsigned int dwTime);
	//bool EditModifyTime(unsigned int dwTime);
	//bool Rotate(double dAngle);
	bool EditCaptureDate(unsigned int dwTime);//ʱ
	bool EditCaptureDate(char *strTime);//ʱ
	bool SetExifSignaTxt(const char *strValue);
	//ʵʳ 0ֵ -1 ʧ
	int GetExifSignaTxt(char *pValue, int iSize);
	bool Save(char* strNewPath = NULL, char *strTempPath = NULL);
	// ֵ: >0ʾ, <0: ʧԭ
	int SaveExifToBuf(void *pBufSrc, int nBufSrc, char**pBufDst);
};
int OExofAnsiResive(char* strAnsi, int len);
void memsetOExifInfo(tagOExifInfo* ptag);
