#pragma once
#include <vector>
#include "OMapApi.h"



class PointClip{
public:
	double m_X;
	double m_Y;
public:
	PointClip(){}
	PointClip(double x, double y){ m_X = x; m_Y = y; }
};

class CLineClip
{

public:
	PointClip pStart;
	PointClip pEnd;
	double a;
	double b;
	double c;
public:
	static bool GetCrossPoint(CLineClip l1, CLineClip l2, PointClip& pCross);

public:
	CLineClip(PointClip pStart, PointClip pEnd);
	void calculateABC();
	CLineClip();
	~CLineClip();
};

typedef struct _tagPointClip
{
	double x;
	double y;
}tagPointClip;
#define LINE_START 1
#define  LINE_MIDDLE 2
#define LINE_END 3
typedef struct _tagPointCross
{
	double x;
	double y;
	int iNext;
	int iNextType;//1 ʾ 2ʾм 3 ʾյ
	int iNextClipLine;
	int iNextClipType;//1 ʾ 2ʾм 3 ʾյ
}tagPointCross;


class CPolygonClip
{
	//ǰαʾԭͼαиĶ߶ΣĶαʾͼڲи߲֡
	//ֵ
	//ڶΪ
	std::vector<tagPointClip> getFirstPart(std::vector<tagPointClip> pPointsSrc, 
	std::vector<tagPointCross> pCrosses, bool bSrcOrderd);
	std::vector<tagPointClip> getSecondPart(std::vector<tagPointClip> pPointsSrc, std::vector<tagPointCross> pCrosses, bool bSrcOrderd);
	std::vector<tagPointClip> getThirdPart(std::vector<tagPointClip> pPointsSrc,  std::vector<tagPointCross> pCrosses, bool bSrcOrderd);
	std::vector<tagPointClip> getForthPart(std::vector<tagPointClip> pPointsClip, std::vector<tagPointCross> pCrosses, bool bSrcOrderd, bool bClipOrderd);

	bool PointInShape(std::vector<tagPointClip> pPointsSrc, tagPointClip PointTrg);
	void Get2ClosePoints(tagPointClip POrg, std::vector<tagPointCross> pCrossesSrc, std::vector<tagPointCross> &pCrossesTrg);
	//Ƭ
	void CombineClips(std::vector<tagPointClip> &clips1, std::vector<tagPointClip> &clips2, std::vector<tagPointClip> pPointsSrc, std::vector<tagPointClip> pPointsClip, std::vector<tagPointCross> pCrosses, bool bSrcOrderd, bool bClipOrderd);

	bool clipPolygon(std::vector<tagPointClip> pPointsSrc, std::vector<tagPointClip> pPointsClip, std::vector<tagPointClip>& vClip1, std::vector<tagPointClip>& vClip2);

public:
	CPolygonClip();
	~CPolygonClip();
#if 0
	//Բδ޸ģδ
	bool clipCADTrack(tagOApiMapTrackV1 *pTrackSrc, tagOApiMapTrackV1 *pTrackClip, tagOApiMapTrackV1* pTrackClip1, tagOApiMapTrackV1* pTrackClip2, bool isYAxixToDown = true);
#endif

	bool clipShape(tagOApiMapShapeV1 *pShapeSrc, tagOApiMapTrackV1 *pTrackClip, tagOApiMapShapeV1 *pShapeClip1, tagOApiMapShapeV1 *pShapeClip2, bool isYAxixToDown = true);
	
};

